; 

    include \masm32\include\masm32rt.inc

comment * -----------------------------------------------------
                        Build this  template with
                       "CONSOLE ASSEMBLE AND LINK"
        ----------------------------------------------------- *

; 

    fcreate MACRO filename
      invoke CreateFile,reparg(filename),GENERIC_READ or GENERIC_WRITE,
                        NULL,NULL,CREATE_ALWAYS,FILE_ATTRIBUTE_NORMAL,NULL
      EXITM <eax>       ; return file handle
    ENDM

    fopen MACRO filename
      invoke CreateFile,reparg(filename),GENERIC_READ or GENERIC_WRITE,
                        NULL,NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,NULL
      EXITM <eax>       ; return file handle
    ENDM

    fclose MACRO arg:REQ
      invoke CloseHandle,arg
    ENDM

    fread MACRO hFile,buffer,bcnt
      LOCAL var
      .data?
        var dd ?
      .code
      invoke ReadFile,hFile,buffer,bcnt,ADDR var,NULL
      mov eax, var
      EXITM <eax>       ; return bytes read
    ENDM

    fwrite MACRO hFile,buffer,bcnt
      LOCAL var
      .data?
        var dd ?
      .code
      invoke WriteFile,hFile,buffer,bcnt,ADDR var,NULL
      mov eax, var
      EXITM <eax>       ; return bytes written
    ENDM

  ; -------------------------------------
  ; variation returns address in register
  ; so it can be assigned to a variable.
  ; -------------------------------------
    repargv MACRO arg
      LOCAL nustr
        quot SUBSTR <arg>,1,1
      IFIDN quot,<">            ;; if 1st char = "
        .data
          nustr db arg,0        ;; write arg to .DATA section
        .code
        mov eax, OFFSET nustr
        EXITM <eax>             ;; return data section offset in eax
      ELSE
        mov eax, arg
        EXITM <eax>             ;; else return arg
      ENDIF
    ENDM

    fprint MACRO hFile:REQ,text:VARARG  ;; zero terminated text
      LOCAL var
      LOCAL pst
      .data?
        var dd ?
        pst dd ?
      .code
      mov pst, repargv(text)
      invoke WriteFile,hFile,pst,len(pst),ADDR var,NULL
      invoke WriteFile,hFile,chr$(13,10),2,ADDR var,NULL
    ENDM

    fseek MACRO hFile,distance,location
      invoke SetFilePointer,hFile,distance,0,location
      EXITM <eax>               ;; return current file offset
    ENDM

  ; -----------------------------------------------
  ; set end of file at curent file pointer location
  ; -----------------------------------------------
    fseteof MACRO hFile
      invoke SetEndOfFile,hFile
    ENDM

    fsize MACRO hFile
      invoke GetFileSize,hFile,NULL
      EXITM <eax>
    ENDM

; 

    .data?              ; place uninitialised data here
      value dd ?

    .data               ; place data with initial value here
      item dd 0

    .code               ; specify the code section

start:                  ; the program code entry point
  
; 

    call main           ; call the main procedure

    exit                ; terminate the program

; 

main proc

    LOCAL hFile :DWORD
    LOCAL bw    :DWORD

    cls
    print "Writing test.txt to disk using the new file IO macros for MASM32",13,10

    mov hFile, fcreate("test.txt")

    .data
      one   db "one",0
      three db "three",0
      five  db "five",0
    .code

    fprint hFile,OFFSET one
    fprint hFile,"two"
    fprint hFile,OFFSET three
    fprint hFile,"four"
    fprint hFile,OFFSET five
    fprint hFile,"six"

    .data
      tst db "This is a test of file IO using the new MASM32 macros."
    .code

    mov bw, fwrite(hFile,ADDR tst,LENGTHOF tst)

    fclose hFile

    ret

main endp

; 

end start               ; program end

Any text after the "end start" directive is not read by the assembler.
